﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@model CyberaniumModels.ICD
@{
    ViewData["Title"] = "Index";
}

<script src="~/Script/Master/Layout.js"></script>
<script src="~/Script/Master/Threat.js"></script>
<script>
    $(document).ready(function () {
        $('.multiple').multiselect({
            enableFiltering: true,
            includeSelectAllOption: true
        });
    });
</script>
<section>
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Normalised Score List</h1>
            <div class="titile_line"></div>
        </div>
        @*@if (ViewBag.message != null)
            {
                <script>toastr.success('@ViewBag.message')</script>
            }
            else if (ViewBag.error != null)
            {
                <script>toastr.error('@ViewBag.error')</script>
            }*@
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="">
                        <form asp-area="ApplicationManagement" asp-controller="SFDC" asp-action="SubmitSFDC"
                              data-ajax="true"
                              data-ajax-method="POST"
                              data-ajax-mode="replace"
                              data-loading-text="loading......"
                              data-ajax-update="#ajaxresult"
                              data-ajax-success="fn_Onsuccess(data,'ApplicationManagement/SFDC/Index');"
                              data-ajax-failure="Errmsg(data);" id="form" method="post">
                            @*@Html.HiddenFor(m => m.ThreatId)*@
                            @Html.HiddenFor(m => m.ParentOrgId)
                            @Html.HiddenFor(m => m.ChildOrgId)
                            @Html.HiddenFor(m => m.CategoryId)
                            @Html.HiddenFor(m => m.AnswerId)
                            <div class="pb-2 mt-4 mb-2 border-bottom box_title" id="title"></div>
                            <div class="row">
                                <div class="col-4">
                                    <div class="view_emp_box1">

                                    </div>
                                    <table class="table table-bordered text-center">
                                        <thead class="bg-warning text-white"><tr><td>Domain</td><td>Base Risk Score</td></tr></thead>
                                        <tbody>
                                            <tr><td class="domains" value="1">Data-confidentiality</td><td id="domain1">0</td></tr>
                                            <tr><td class="domains" value="2">Communication Security</td><td id="domain2">0</td></tr>
                                            <tr><td class="domains" value="3">Data Integrity</td><td id="domain3">0</td></tr>
                                            <tr><td class="domains" value="4">Availability</td><td id="domain4">0</td></tr>
                                            <tr><td class="domains" value="5">Privacy</td><td id="domain5">0</td></tr>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                            <div class="panel-group" id="accordion" role="tablist" aria-multiselectable="false">
                                @foreach (var item in Model.ThreatList)
                                {
                                    <div class="panel panel-default">
                                        @foreach (var ele in Model.DomainThreatMapList.Where(x => x.ThreatId == item.ThreatId))
                                        {
                                            <input type="hidden" class="domain@(ele.DomainId)" id="@(ele.DomainId+"_"+item.ThreatId)" value="@(ele.Status?1:0)" />
                                        }
                                        <div class="panel-heading" role="tab" id="heading@(item.ThreatId)">
                                            <h4 class="panel-title">
                                                <a class="collapsed" role="button" data-toggle="collapse" data-parent="#accordion" href="#collapse@(item.ThreatId)" aria-expanded="false" aria-controls="collapse@(item.ThreatId)" onclick="GetControls(this,'@item.ThreatId')">
                                                    @(item.ThreatCode +" - "+ item.ThreatName)
                                                </a>
                                            </h4>
                                        </div>
                                        <style>
                                            .txtCenter th {
                                                text-align: center
                                            }

                                            .txtCenter td {
                                                text-align: center
                                            }
                                        </style>
                                        <div id="collapse@(item.ThreatId)" class="panel-collapse collapse" role="tabpanel" aria-labelledby="heading@(item.ThreatId)">
                                            <div class="panel-body">
                                                <div class="row">
                                                    <div class="col-12">
                                                        <div class="table_control">
                                                            <table class="table">
                                                                <thead class="txtCenter">
                                                                    <tr>
                                                                        <th>Probability</th>
                                                                        <th>Impact</th>
                                                                        <th>Average P</th>
                                                                        <th>Average D,C</th>
                                                                        <th>Revised Probability Score</th>
                                                                        <th>Revised Impact</th>
                                                                        <th>Threat Residual Risk</th>
                                                                    </tr>
                                                                </thead>
                                                                <tbody>
                                                                    <tr class="txtCenter">
                                                                        <td id="Probability@(item.ThreatId)">@(item.Score)</td>
                                                                        <td id="Impact@(item.ThreatId)">1</td>
                                                                        <td id="AvgP@(item.ThreatId)">@(item.Score)</td>
                                                                        <td id="AvgDC@(item.ThreatId)">1</td>
                                                                        <td id="RPS@(item.ThreatId)">@(item.Score)</td>
                                                                        <td id="RI@(item.ThreatId)">1</td>
                                                                        <td id="TRR@(item.ThreatId)">@(item.Score*1)</td>
                                                                    </tr>
                                                                    <tr>
                                                                        <td colspan="7">
                                                                            <table class="table m-0">
                                                                                <thead class="txtCenter">
                                                                                    <tr>
                                                                                        <th>SNo</th>
                                                                                        <th>Control ID</th>
                                                                                        <th>Control Name</th>
                                                                                        <th>Control Description</th>
                                                                                        <th>Control Type</th>
                                                                                        <th>Control Ratings</th>
                                                                                        <th>GAPs Identified</th>
                                                                                    </tr>
                                                                                </thead>
                                                                                <tbody id="ThreatDomain@(item.ThreatId)"></tbody>
                                                                            </table>
                                                                        </td>
                                                                    </tr>
                                                                </tbody>
                                                            </table>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                }
                                <script>
                                    function GetControls(ele, id) {
                                        var html = '';
                                        $('#preloader').show();
                                        $(ele).removeAttr('onclick');
                                        $.get('/Master/IntregratedControl/GetControlsByThreatId', { id: parseInt(id) }, function (controlList) {
                                            if (controlList.data.length > 0) {
                                                $.each(controlList.data, function (di, dvalue) {
                                                    var ControlType = dvalue.controlTypeId == '1' ? 'D' : dvalue.controlTypeId == '2' ? 'C' : 'P';
                                                    html += '<tr>' +
                                                        '<td class="text-center">' + ++di + '</td>' +
                                                        '<td>' + dvalue.controlId + '</td>' +
                                                        '<td>' + dvalue.controlName + '</td>' +
                                                        '<td>' + dvalue.controlDescription + '</td>' +
                                                        '<td class="text-center" name="td' + id + '" style="font-weight:bolder">' + ControlType + '</td>' +
                                                        '<td><input type="number" class="form-control" name="rating_' + id + '" min="1" max="5" onchange="calculateAverage(this)" /></td>' +
                                                        '<td><textarea style="width:400px;height:100px;" class="form-control"></textarea></td>' +
                                                        '</tr>';
                                                });
                                                html += '<tr><td colspan="7" class="text-right"><input type="button" class="btn btn-info" value="Save" onclick="SubmitDataByAnswer(\'' + id + '\')" /></td></tr>';
                                            }
                                            setTimeout(function () {
                                                $('#ThreatDomain' + id).append(html);
                                                $('#preloader').hide();
                                            }, 1000);
                                        });
                                    }
                                    function SubmitDataByAnswer(threatId) {
                                        var parentOrgId = $('#ParentOrgId').val(), childOrgId = $('#ChildOrgId').val() == '' ? 0 : $('#ChildOrgId').val(), categoryId = $('#CategoryId').val(), answerId = $('#AnswerId').val(), DomainBaseRiskScoreXML = [];
                                        $('.domains').each(function (i, ele) {
                                            var domainId = parseInt($(ele).attr('value'));
                                            var score = parseFloat($('#domain' + domainId).text());
                                            DomainBaseRiskScoreXML[i] = {
                                                DomainId: domainId,
                                                Score: score
                                            }
                                        });
                                        var model = {
                                            ParentOrgId: parentOrgId,
                                            ChildOrgId: childOrgId,
                                            CategoryId: categoryId,
                                            AnswerId: answerId,
                                            DomainBaseRiskScoreXML: JSON.stringify(DomainBaseRiskScoreXML)
                                        }
                                        $.post('/ApplicationManagement/SFDC/SubmitDataByAnswer', { model: model }, function (res) {
                                            if (res.isSuccess) {
                                                toastr.success('Saved successfully.');
                                            }
                                        });
                                    }
                                    function calculateAverage(input) {
                                        var name = $(input).attr('name'), id = parseInt(name.split('_')[1]), cTotal = 0, cLength = 0, pTotal = 0, pLength = 0;
                                        $('[name="' + name + '"]').each(function (i, ele) {
                                            var val = $(ele).val();
                                            if (val == '') return;
                                            if (parseInt(val) > 5 || parseInt(val) < 1) {
                                                toastr.warning('Control rating should be between 1 to 5');
                                                $(ele).val('');
                                                $('[name="td' + id + '"]').eq(i).css('color', 'black');
                                                $('[name="td' + id + '"]').eq(i).css('background-color', 'white');
                                                return;
                                            } else {
                                                var textColor = parseInt(val) > 0 && parseInt(val) != 3 ? 'white' : parseInt(val) == 3 ? 'black' : 'black';
                                                var bgColor = parseInt(val) > 0 ? parseInt(val) == 1 ? '#800000' : parseInt(val) == 2 ? '#ff0000' : parseInt(val) == 3 ? '#FFFF00' : parseInt(val) == 4 ? '#90EE90' : '#006400' : '';
                                                $('[name="td' + id + '"]').eq(i).css('color', textColor);
                                                $('[name="td' + id + '"]').eq(i).css('background-color', bgColor);
                                            }
                                            var text = $('[name="td' + id + '"]').eq(i).text();
                                            if (text == 'P' && val != '') pLength++; else cLength++;
                                            if (val == '') return;
                                            if (text == 'P') {
                                                pTotal += parseInt(val);
                                            } else {
                                                cTotal += parseInt(val);
                                            }
                                        });
                                        var p = parseInt($('#Probability' + id).text());
                                        var i = parseInt($('#Impact' + id).text());
                                        $('#Impact' + id).text('1');

                                        if (pTotal > 0 && pLength > 0) {
                                            $('#AvgP' + id).text((pTotal / pLength).toFixed(2));
                                            var ap = parseFloat($('#AvgP' + id).text());
                                            var rp = ap <= 1 ? p * 1 : ap <= 2 ? p * 0.8 : ap <= 3 ? p * 0.5 : ap <= 4 ? p * 0.3 : p * 0.1;
                                            $('#RPS' + id).text(rp.toFixed(2));
                                        }
                                        if (cTotal > 0 && cLength > 0) {
                                            $('#AvgDC' + id).text((cTotal / cLength).toFixed(2));
                                            var ac = parseFloat($('#AvgDC' + id).text());
                                            var ri = ac <= 1 ? i * 1 : ac <= 2 ? i * 0.8 : ac <= 3 ? i * 0.5 : ac <= 4 ? i * 0.3 : i * 0.1;
                                            $('#RI' + id).text(ri.toFixed(2));
                                        }
                                        debugger;
                                        var trr = (1 + ((rp * (typeof (ri) === 'undefined' ? 1 : ri)) - 0.01) * ((5 - 1) / (5 - 0.01)));
                                        $('#TRR' + id).text(trr.toFixed(2));
                                        calculateBaseRiskScore();
                                    }
                                    function calculateBaseRiskScore() {
                                        $('.domains').each(function (dI, dEle) {
                                            var dVal = parseInt($(this).attr('value')), length = 0, value = 0;
                                            $('.domain' + dVal).each(function (i, ele) {
                                                var id = parseInt($(this).attr('id').split('_')[1]);
                                                var val = parseInt($(this).val());
                                                if (val > 0) {
                                                    value += parseFloat($('#TRR' + id).text());
                                                    length++;
                                                }
                                            });
                                            $('#domain' + dVal).text((value / length).toFixed(2) === 'NaN' ? 0 : (value / length).toFixed(2));
                                        });
                                    }
                                </script>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
<script type="text/javascript">
    $(document).ready(function () {
        $("#btnsubmit").show();
        if ($("#ThreatId").val() > 0) {
            $(".titile_heading h1").html("Edit Normalised Score");
            $(".service_line").addClass("active");
            $(".assign_panel").hide();
            $(".titile_heading").show();
        } else {
            $(".titile_heading h1").html("Normalised Score list");
            $(".service_line").removeClass("active");
            $(".assign_panel").show();
            $(".titile_heading").show();
        }
        calculateBaseRiskScore()
    })
    function AddButton() {
        $(".titile_heading h1").html("Add Normalised Score");
        $(".service_line").addClass("active");
        $(".assign_panel").hide();
        //$(".titile_heading").show();}
    }
    function BackButton() {
        $(".titile_heading h1").html("Normalised Score List");
        $(".service_line").removeClass("active");
        $(".assign_panel").show();
        //$(".titile_heading").show();
        //$("#viewbutton").show();
    }
    function fnBlockDelete(ThreatId, Action, Type) {
        $.getJSON('/Master/Threat/BlockDeleteThreat', { ThreatId: ThreatId, Type: Type }, function (data) {
            if (data > 0) {
                if (Type > 0) {
                    toastr.success(Action + " " + "successfully");
                } else {
                    toastr.success(Action + " " + "successfully");
                }
                setTimeout(function () { window.location.reload(); }, 2000);
            }
        });
    }
    $("input[type=submit]").click(function (event) {
        //if ($("select[name=TlevelId]").val() == 0) {
        //    event.preventDefault();
        //    toastr.error("Select threat level");
        //} else
        if ($("select[name=TTypeId]").val() == 0 && $("select[name=TTypeId]").val() == "") {
            event.preventDefault();
            toastr.error("Select threat type");
        } else if ($("input[name=ThreatName]").val() == "") {
            event.preventDefault();
            toastr.error("Threat name is required.");
        }
    })
    function Confirmation(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to delete this threat',
            showCancelButton: true,
            confirmButtonText: 'Delete',
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/Master/Threat/BlockDeleteThreat",
                    type: "POST",
                    cache: false,
                    data: { id: id, Type: Type = 1 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success("Delete successfully!!");
                        $('a[href="/Master/Threat/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
    function fn_Activeincative(id, status) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to ' + status + ' this Threat',
            showCancelButton: true,
            confirmButtonText: status,
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/Master/Threat/BlockDeleteThreat",
                    type: "POST",
                    cache: false,
                    data: { id: id, Type: Type = 0 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success(status + " " + "successfully!!");
                        $('a[href="/Master/Threat/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
</script>

